// #pragma comment(linker, "/stack:200000000")
// #pragma GCC optimize("Ofast,no-stack-protector")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
// #pragma GCC optimize("unroll-loops")

#include <stdio.h>
#include <bits/stdc++.h>

#ifdef PERVEEVM_LOCAL
    #define debug(x) std::cerr << (#x) << ":\t" << (x) << std::endl
#else
    #define debug(x) 238
#endif

#define fastIO std::ios_base::sync_with_stdio(false); std::cin.tie(0); std::cout.tie(0)
#define NAME "File"

using ll = long long;
using ld = long double;

#ifdef PERVEEVM_LOCAL
    std::mt19937 rnd(238);
#else
    std::mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());
#endif

template<typename T>
bool smin(T& a, const T& b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool smax(T& a, const T& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

const double PI = atan2(0.0, -1.0);
const int INF = 0x3f3f3f3f;
const ll LINF = (ll)2e18;

void solve() {
	int a, b, k;
	ll m;
	scanf("%d%d%d%lld", &a, &b, &k, &m);

	ll d = 1ll * k * k - 4ll * (m - k - 1);
	if (d < 0) {
		printf("-1\n");
		return;
	}

	ll sqrtD = (ll)sqrtl(d);
	while (sqrtD * sqrtD > d) {
		--sqrtD;
	}
	while ((sqrtD + 1) * (sqrtD + 1) <= d) {
		++sqrtD;
	}

	if (sqrtD * sqrtD != d || k % 2 != sqrtD % 2) {
		printf("-1\n");
		return;
	}

	ll x1 = (k - sqrtD) / 2;
	ll x2 = (k + sqrtD) / 2;

	if (x1 >= 0 && x1 < a && k - x1 >= 0 && k - x1 < b) {
		printf("%lld %lld\n", x1, k - x1);
	} else if (x2 >= 0 && x2 < a && k - x2 >= 0 && k - x2 < b) {
		printf("%lld %lld\n", x2, k - x2);
	} else {
		printf("-1\n");
	}
}

void run() {
    int t;
    scanf("%d", &t);

    while (t--) {
    	solve();
    }
}

int main(void) {
    // freopen(NAME".in", "r", stdin);
    // freopen(NAME".out", "w", stdout);

    #ifdef PERVEEVM_LOCAL
        auto start = std::chrono::high_resolution_clock::now();
    #endif

    run();

    #ifdef PERVEEVM_LOCAL
        auto end = std::chrono::high_resolution_clock::now();
        std::cerr << "Execution time: "
                  << std::chrono::duration_cast<std::chrono::milliseconds>(end - start).count()
                  << " ms" << std::endl;
    #endif

    return 0;
}
