#include "bits/stdc++.h"

using namespace std;
using ll = long long;

#define all(x) x.begin(), x.end()

ll exact_sqrt(ll d) {
    ll inexact = sqrt(d);
    for (ll x = max(0LL, inexact - 10); x < inexact + 10; x++) {
        if (x * x == d) return x;
    }
    return -1;
}

// min x: x >= 0 and x * (k - x) = a
// -1 if no root, or it is not an integer
ll solve_quad(ll k, ll a) {
    ll d = k * k - 4 * a;
    if (d < 0) return -1;
    ll sqd = exact_sqrt(d);
    if (sqd == -1) return -1;
    if (k >= sqd && (k - sqd) % 2 == 0) return (k - sqd) / 2;
    if ((k + sqd) % 2 == 0) return (k + sqd) / 2;
    return -1;
}

void solve() {
    ll a, b, k, m;
    cin >> a >> b >> k >> m;
    ll hv = m - k - 1;
    if (hv < 0) {
        cout << -1 << "\n";
        return;
    }
    ll h = solve_quad(k, hv);
    ll v = k - h;
    if (h == -1) {
        cout << -1 << "\n";
        return;
    }
    if (h < a and v < b) {
        cout << h << " " << v << "\n";
    } else if (h < b and v < a) {
        cout << v << " " << h << "\n";
    } else {
        cout << -1 << "\n";
        return;
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
