import sys
import math

curtest = 1

maxans = 0

MAX = 10**18
MAXT = 50
f = [2, 3]
while f[-1] + f[-2] < MAX:
    f.append(f[-1] + f[-2])

#print(len(f), f)

def count(n, f):
    if n == 1:
        return 1
    if f >= len(z) or n < z[f]:
        return 0
    res = 0
    for i in range(f, len(z)):
        x = z[i]
        if n % x == 0:
            res += count(n // x, i)
    return res

def solve(n):
    global z
    global maxans
    z = []
    for x in f:
        if n % x == 0:
            z.append(x)
    ans = count(n, 0)
    if ans > maxans:
        maxans = ans
    return ans

# subtask 2: n <= 10**5
def test(a):
    global curtest
    global was
    f = open("%02d" % curtest, "w")
    print(len(a), file=f)
    for x in a:
        print(x, file=f)
        solve(x)
    f.close()
#    print(len(a), a)
    curtest += 1

def cuttests(a):
    while len(a) > MAXT:
        test(a[:MAXT])
        a = a[MAXT:]
    test(a)


import random
random.seed("iwfsh")

test([2, 7, 8, 40, 64])


# subtask 1: n <= 100
print("subtask 1:", curtest)
cuttests([i for i in range(2, 101)])

# subtask 2: n <= 10**5
print("subtask 2:", curtest)
a = []
for n in range(101, 10**5 + 1):
    if solve(n) > 2:
        a.append(n)
        if len(a) == MAXT:
            test(a)
            a = []
test(a)

a = []
for t in range(50):
    a.append(random.randint(2, 10**5))
test(a)

def random_yes_linear(MAX):
    n = random.randint(2, MAX)
#    print(n, end="...")
    while solve(n) == 0:
        n += 1
#    print(n)
    return n

def random_yes_mul(MAX):
    n = 1
    found = True
    while found:
        retries = 0
        found = False
        while retries < 10:
            r = random.randint(0, len(good) - 1)
            if n * good[r] <= MAX:
                n = n * good[r]
                found = True
                break
            else:
                retries += 1
    return n

def random_big(MAX, big):
    while True:
        n = random.randint(2, MAX)
        if solve(n) >= big:
            break
    return n


a = []
for t in range(50):
    n = random_yes_linear(10**5)
    a.append(n)

test(a)

# subtask 3: n is 2^k
print("subtask 3:", curtest)
a = [2**i for i in range(1, 60)]
cuttests(a)

good = []
for i in range(2, 100000):
    v = solve(i)
    if v > 1:
        good.append(i)

#print("good:", good)
    

# subtask 4: n <= 10**9
print("subtask 4:", curtest)
a = []
MAXN = 10**9
for x in range(60):
    for y in range(40):
        n = 2**x * 3**y
        if 2 <= n <= MAXN:
            a.append(n)

for i in range(50):
    a.append(random_yes_mul(MAXN))
    a.append(random.randint(2, MAXN))

while len(a) % MAXT != 0:
    a.append(random_yes_mul(MAXN))    

cuttests(a)

# subtask 5: n <= 10**18
print("subtask 5:", curtest)
a = []
MAXN = 10**18
for x in range(60):
    for y in range(40):
        n = 2**x * 3**y
        if 2 <= n <= MAXN and solve(n) > 20:
            a.append(n)

for i in range(50):
    a.append(random_yes_mul(10**18))
    a.append(random.randint(2, 10**18))

while len(a) % MAXT != 0:
    a.append(random_yes_mul(10**18))    

cuttests(a)

print("maxans =", maxans)