#include "testlib.h"

using namespace std;


void gen_ladder(int cnt, int size, int offset) {
    static vector<char> const d{'N', 'W', 'S', 'E'};
    for (int i = 0; i < cnt; i++) {
        println(d[(offset + i) % 2], rnd.wnext(max(size / 2, 1), size, 2));
    }
}

void gen_spiral(int cnt, int size) {
    static vector<char> const d{'N', 'W', 'S', 'E'};
    int step = size / cnt;
    for (int i = 0; i < cnt; i++) {
        println(d[i % 4], max(size, 1));
        size -= step;
    }
}

void gen_grid(int cnt, int size) {
    int first = cnt / 2;
    ensuref(first % 4 == 3, "Invalid grid size");
    int small = max(size / first, 1);

    static vector<char> const d1{'N', 'W', 'S', 'W'};
    for (int i = 0; i < first; i++) {
        int a = i % 2 == 0 ? size : small;
        println(d1[i % 4], rnd.wnext(max(a / 2, 1), a, 3));
    }

    static vector<char> const d2{'E', 'N', 'W', 'N'};
    for (int i = first; i < cnt; i++) {
        int a = i % 2 == 0 ? size : small;
        println(d2[i % 4], rnd.wnext(max(a / 2, 1), a, 3));
    }
}

void gen_rnd(int cnt, int size) {
    static vector<char> const d{'N', 'W', 'S', 'E'};
    for (int i = 0; i < cnt; i++) {
        println(d[rnd.next(d.size())], rnd.next(1, size));
    }
}

int main(int argc, char *argv[]) {

    registerGen(argc, argv, 1);
    int k = opt<int>("k"), n = opt<int>("n");
    int alim = opt<int>("alim");

    int ladder = opt<double>("ladder") * n,
            spiral = opt<double>("spiral") * n,
            grid = opt<double>("grid") * n;

    println(k, n);

    if (ladder > 0) {
        ladder -= ladder % 4;
        vector<int> offset{0, 1, 2, 3};
        shuffle(offset.begin(), offset.end());
        for (int q : offset) {
            gen_ladder(ladder / 4, alim, q);
        }
    }
    if (spiral > 0) {
        gen_spiral(spiral, alim);
    }
    if (grid > 0) {
        while ((grid / 2) % 4 != 3) grid--;
        gen_grid(grid, alim);
    }
    gen_rnd(n - ladder - spiral - grid, alim);

}