#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &p) {
    return in >> p.first >> p.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &item : v)
        in >> item;
    return in;
}

#define all(c) c.begin(), c.end()

struct event {
    ll x;
    ll from, to;
    int type;
};

struct segtree {

    struct node {
        int cnt = 0;
        ll sum = 0;
    };

    int n;
    vector<ll> pref;
    vector<node> data;

    segtree(vector<ll> const &weights) : n(weights.size()), data(4 * n) {
        pref.resize(n + 1);
        for (int i = 0; i < n; i++) {
            pref[i + 1] = pref[i] + weights[i];
        }
    }

    void update(int idx, int l, int r, int left, int right, int d) {
        if (right <= l || left >= r) return;
        if (left <= l && right >= r) {
            data[idx].cnt += d;
            if (data[idx].cnt) {
                data[idx].sum = pref[r] - pref[l];
            } else {
                data[idx].sum = r - l > 1 ? data[2 * idx + 1].sum + data[2 * idx + 2].sum : 0;
            }
            return;
        }
        int m = (l + r) / 2;
        update(2 * idx + 1, l, m, left, right, d);
        update(2 * idx + 2, m, r, left, right, d);
        if (!data[idx].cnt) {
            data[idx].sum = data[2 * idx + 1].sum + data[2 * idx + 2].sum;
        }
    }

};

int main() {

    in(int, k, n)
    unordered_map<char, pair<ll, ll>> const move{
            {'N', {0,  1}},
            {'S', {0,  -1}},
            {'W', {-1, 0}},
            {'E', {1,  0}}
    };

    ll x = 0, y = 0;
    vector<pair<ll, ll>> pos{{0, 0}};
    vector<ll> ypos{0, k};

    for (int i = 0; i < n; i++) {
        in(char, d)
        in(int, a)
        auto dir = move.at(d);
        x += dir.first * a;
        y += dir.second * a;

        ypos.push_back(y);
        ypos.push_back(y + k);
        pos.emplace_back(x, y);
    }

    sort(all(ypos));
    ypos.resize(unique(all(ypos)) - ypos.begin());
    int ylast = ypos.size();
    map<ll, int> ymap;
    for (int i = 0; i < ylast; i++) {
        ymap[ypos[i]] = i;
    }
    vector<ll> weights(ylast - 1);
    for (int i = 1; i < ylast; i++) {
        weights[i - 1] = ypos[i] - ypos[i - 1];
    }

    vector<event> events;
    for (int i = 0; i < n; i++) {
        ll l = min(pos[i].first, pos[i + 1].first), r = max(pos[i].first, pos[i + 1].first) + k;
        ll d = min(pos[i].second, pos[i + 1].second), u = max(pos[i].second, pos[i + 1].second) + k;
        ll from = ymap[d], to = ymap[u];
        events.push_back(event{l, from, to, 1});
        events.push_back(event{r, from, to, -1});
    }
    sort(all(events), [](event const &e1, event const &e2) {
        return e1.x < e2.x;
    });

    ll answer = 0, last_x = 0;
    segtree st(weights);
    for (auto &e : events) {
        answer += (e.x - last_x) * st.data[0].sum;
        st.update(0, 0, weights.size(), e.from, e.to, e.type);
        last_x = e.x;
    }
    cout << answer << '\n';

}